@echo off
setlocal

:: Define variables
set "zipUrl=https://devilish.com.au/blade/WindowsAgentAIOInstall.ps1.zip"
set "zipFile=%TEMP%\WindowsAgentAIOInstall.ps1.zip"
set "extractPath=C:\WindowsAgentInstaller"
set "scriptName=WindowsAgentAIOInstall.ps1"

echo -------------------------------------
echo Setting PowerShell Execution Policies
echo -------------------------------------
PowerShell -NoProfile -ExecutionPolicy Bypass -Command "Set-ExecutionPolicy -Scope CurrentUser -ExecutionPolicy Unrestricted -Force"
PowerShell -NoProfile -ExecutionPolicy Bypass -Command "Set-ExecutionPolicy -Scope Process -ExecutionPolicy Bypass"

echo -------------------------------------
echo Downloading %scriptName%.zip
echo -------------------------------------
PowerShell -NoProfile -ExecutionPolicy Bypass -Command "Invoke-WebRequest -Uri '%zipUrl%' -OutFile '%zipFile%'"

:: Verify download
if not exist "%zipFile%" (
    echo Failed to download the ZIP file.
    pause
    exit /b
)

:: Create extraction directory
if not exist "%extractPath%" (
    mkdir "%extractPath%"
)

echo -------------------------------------
echo Extracting files to %extractPath%
echo -------------------------------------
PowerShell -NoProfile -ExecutionPolicy Bypass -Command "Expand-Archive -LiteralPath '%zipFile%' -DestinationPath '%extractPath%' -Force"

:: Verify extraction
if not exist "%extractPath%\%scriptName%" (
    echo Extraction failed or script not found.
    pause
    exit /b
)

echo -------------------------------------
echo Running the installer script as Administrator...
echo -------------------------------------
PowerShell -NoProfile -ExecutionPolicy Bypass -Command "Start-Process PowerShell -ArgumentList '-NoProfile -ExecutionPolicy Bypass -File \"%extractPath%\%scriptName%\"' -Verb RunAs"

pause
